sylware / nyanlinux (public) (License: AFFERO GPLv3) (since 2019-09-09) (hash sha1)
scripts for a lean, from scratch, amd hardware, linux distro

/files/hls (d3020698d526d25b59dc873924a5f9f9a27c2d7d) (1960 bytes) (mode 100755) (type blob)

#!/bin/sh

#-------------------------------------------------------------------------------
cleanup ()
{
	rm $backlog
	rm ${backlog}.new
	rm $m3u8
	rm $segment
}
trap cleanup HUP INT QUIT ABRT PIPE TERM EXIT
#-------------------------------------------------------------------------------

python=/nyan/python3/current/bin/python3
yd="$python /root/bin/y"
curl=/nyan/curl/current/bin/curl
m3u8="/run/$1"
backlog="/run/$1_backlog"

fmt=${2:-best}
hls=$($python /root/bin/y -g -f $fmt "https://www.twitch.tv/$1")
if test -z "$hls"; then
	exit 1
fi

rm -f $m3u8
$curl -s -S -o $m3u8 $hls >/dev/null
if test $? -ne 0; then
	echo "unable to download the m3u8 hls playlist $hls"
	exit 1
fi
if ! egrep '^#EXTM3U' <$m3u8 >/dev/null; then
	echo "the downloaded file $m3u8 is not a m3u8 playlist"
	exit 1
fi

truncate -s 0 $backlog

while true; do
	while IFS= read -r line; do
		if echo "$line" | egrep '^http' >/dev/null; then
			if ! echo "$line" | grep -F -f $backlog >/dev/null; then
				segment=$(mktemp -p /run)
				$curl -m 8 --retry 3 --retry-delay 1 -s -S "$line" >$segment
				ret=$?
				if test $ret -eq 23; then # write error/keep it explicit
					echo "unable to write segment $segment"
					rm -f $segment
					exit 1
				elif test $ret -ne 0; then
					echo "unable to download segment $segment"
					rm -f $segment
					exit 1
				fi
				if ! cat $segment; then
					echo "unable to pipe the segment $segment"
					rm -f $segment
					exit
				fi
				rm -f $segment
				echo "$line" >>$backlog
			fi
		fi
	done <$m3u8

	if test $(wc -l <$backlog) -gt 400 ; then
		tail -n 200 $backlog >${backlog}.new
		mv -f ${backlog}.new $backlog
		rm -f ${backlog}.new
	fi

	rm -f $m3u8
	$curl -m 8 --retry 3 --retry-delay 1 -s -S -o $m3u8 $hls >/dev/null
	if test $? -ne 0; then
		echo "unable to download the m3u8 hls playlist $hls"
		exit
	fi
	if ! egrep '^#EXTM3U' <$m3u8 >/dev/null; then
		echo "the downloaded file $m3u8 is not a m3u8 playlist"
		exit
	fi
done


Mode Type Size Ref File
100644 blob 5 8eba6c8dd4dcaf6166bd22285ed34625f38a84ff .gitignore
100755 blob 2487 533016d4902080b22ae5dc5352802ebdd0d78b16 01-x86_64-nyan-linux-gnu.sh
100755 blob 4254 31fdc18cc3e6c6cfd8444fa404f7e82f849bad56 02-nyan-cross-core.sh
100755 blob 3549 7f1362bad6786a6818ce7a7d613d0dc11f611fb9 03-nyan-cross-x11.sh
100755 blob 12534 f9036d33f9f159ea2421ce1a1ebf7067f0f695c1 04-bootstrap-conf.sh
100755 blob 671 5f6bc5de83a883da3a7f0d4a37e1d0ef51c08561 10-sdk-conf.sh
100755 blob 2201 83fa9bf5bddbecb88db53779e324b9f270b1080e 11-sdk.sh
100755 blob 2826 090b622caebd38755ef1e57a9cf0f4f673b22a8e 12-desktop.sh
100755 blob 129 08460f0dece90701f01cbf7d710609ecbb3d56e0 13-beyond.sh
100644 blob 1075 1b5314b511d4c6dc7eb4db36a21dd47ba5a00a9d INSTALL
100644 blob 30 c9b735fa1332286f4b3f5f81fa10527fd7506b6e LICENSE
100644 blob 2657 64868dc96404c69ad85b979986821d6eb0420f9a README
040000 tree - f77ddb4c216d5c842f54fa8a5b6a7374d8678400 builders
100644 blob 2986 43344438bb4d817ff81f1890de1097f627c6d6c4 conf.sh
040000 tree - 84401dd4d78de6fafa1b3f59ccf2a0c62ecc705e files
100755 blob 351 6af534903b47d67a8dcb71653e7a0e1c1a4dfda4 pkg-build
100755 blob 289 7f5fbdbb712f274d04a036b9c486cbc9cf581be6 pkg-build-target
100644 blob 915 a7f21134dbc05d0e8227eaee366856b8171832a4 sdk.sh
100644 blob 22800641 e9e6291054c857401f6835c728f31541dae4311e steam.tar.bz2
040000 tree - 3ea8b6a0976e4a31f94cf63a35646cd184a55d4a x86
Hints:
Before first commit, do not forget to setup your git environment:
git config --global user.name "your_name_here"
git config --global user.email "your@email_here"

Clone this repository using HTTP(S):
git clone https://rocketgit.com/user/sylware/nyanlinux

Clone this repository using ssh (do not forget to upload a key first):
git clone ssh://rocketgit@ssh.rocketgit.com/user/sylware/nyanlinux

Clone this repository using git:
git clone git://git.rocketgit.com/user/sylware/nyanlinux

You are allowed to anonymously push to this repository.
This means that your pushed commits will automatically be transformed into a merge request:
... clone the repository ...
... make some changes and some commits ...
git push origin main